From d8f7684447a0ccc7a98c42a2eb1b5fcf8c9a0732 Mon Sep 17 00:00:00 2001
From: Shaily <shaily15297@yahoo.com>
Date: Feb 05 2018 14:33:19 +0000
Subject: [PATCH 28/32] Issues: Update widget on backend change


---

diff --git a/hubs/static/client/app/widgets/issues/Widget.js b/hubs/static/client/app/widgets/issues/Widget.js
index 889d749..98bc88b 100644
--- a/hubs/static/client/app/widgets/issues/Widget.js
+++ b/hubs/static/client/app/widgets/issues/Widget.js
@@ -1,5 +1,9 @@
 import React from 'react';
 import { apiCall } from '../../core/utils';
+import {
+  widgetDidUpdate,
+  widgetWillUpdate
+  } from "../../core/actions/widget";
 import WidgetChrome from '../../components/WidgetChrome';
 import PropTypes from "prop-types";
 import Spinner from "../../components/Spinner";
@@ -7,7 +11,7 @@ import Issue from "./Issue";
 import Footer from "./Footer";
 
 
-export default class IssuesWidget extends React.PureComponent {
+export default class IssuesWidget extends React.Component {
 
   constructor(props) {
     super(props);
@@ -26,11 +30,26 @@ export default class IssuesWidget extends React.PureComponent {
     }
   }
 
+  componentDidUpdate(prevProps, prevState) {
+    if (this.props.needsUpdate && !this.props.editMode && !this.state.isLoading) {
+      this.loadFromServer();
+    }
+  }
+
   loadFromServer() {
+    this.props.dispatch(widgetWillUpdate(this.props.widget.idx));
     this.setState({isLoading: true});
     apiCall(this.props.widget.urls.data).then(
       (data) => {
-        this.setState({issues: data.issues, counts: data.counts, isLoading: false});
+        this.setState({
+          issues: data.issues,
+          counts: data.counts,
+          isLoading: false,
+        },
+          () => (
+            this.props.dispatch(widgetDidUpdate(this.props.widget.idx))
+          )
+        );
       },
       (error) => {
         this.setState({error: error.message, isLoading: false});

